//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DimGray
#property indicator_color2  Gray
#property indicator_color3  LimeGreen
#property indicator_color4  DeepPink
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_style1  STYLE_DOT
#property indicator_level1  0

//
//
//
//
//

extern string TimeFrame           = "Current time frame";
extern double TTFbars             =  14;
extern int    topLine             =  100;
extern int    bottomLine          = -100;
extern double T3Hot               =  1.0;
extern bool   T3Original          = false;
extern bool   showTopBottomLevels = true;
extern bool   showSignals         = true;

//
//
//
//
//

double ttf[];
double lev[];
double sigu[];
double sigd[];
double trend[];
double trends[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,lev);
      SetIndexBuffer(1,ttf);
      SetIndexBuffer(2,sigu); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);
      SetIndexBuffer(3,sigd); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);
      SetIndexBuffer(4,trend);
      SetIndexBuffer(5,trends);
      
      //
      //
      //
      //
      //
   
        indicatorFileName = WindowExpertName();
        returnBars        = (TimeFrame == "returnBars");     if (returnBars)     return(0);
        calculateValue    = (TimeFrame == "calculateValue"); if (calculateValue) return(0);
        timeFrame         = stringToTimeFrame(TimeFrame);   

     //
     //
     //
     //
     //
   
    IndicatorShortName(timeFrameToString(timeFrame)+"  TTF T3 Smoothed  ");           
    return(0);
}

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { lev[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
   
   for(int i=limit; i >= 0; i--)
   {
      double HighestHighRecent = High[iHighest(NULL,0,MODE_HIGH,TTFbars,i)];
      double HighestHighOlder  = High[iHighest(NULL,0,MODE_HIGH,TTFbars,i+TTFbars)];
      double LowestLowRecent   =  Low[iLowest(NULL, 0,MODE_LOW, TTFbars,i)];
      double LowestLowOlder    =  Low[iLowest(NULL, 0,MODE_LOW, TTFbars,i+TTFbars)];
      
         double BuyPower  = HighestHighRecent - LowestLowOlder;
         double SellPower = HighestHighOlder  - LowestLowRecent;
               ttf[i] = iT3((BuyPower-SellPower)/(0.5*(BuyPower+SellPower))*100.0,TTFbars,T3Hot,T3Original,i);
      
      //
      //
      //
      //
      //
         
      if (showTopBottomLevels)
      {
         trend[i] = trend[i+1];
            if (ttf[i] > 0) trend[i] =  1;
            if (ttf[i] < 0) trend[i] = -1;
            if (trend[i]== 1) lev[i] = topLine;
            if (trend[i]==-1) lev[i] = bottomLine;
      }
      
      if (showSignals)
      {
         sigu[i] = EMPTY_VALUE;
         sigd[i] = EMPTY_VALUE;
         trends[i] = 0;
            if (ttf[i] > topLine)    trends[i] =  1;
            if (ttf[i] < bottomLine) trends[i] = -1;
            if (trends[i]== 1) sigu[i] = topLine;
            if (trends[i]==-1) sigd[i] = bottomLine;
      }
   }
   return(0);
   }

   //
   //
   //
   //
   //       
    
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period())); 
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         lev[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TTFbars,topLine,bottomLine,T3Hot,T3Original,showTopBottomLevels,showSignals,0,y);
         ttf[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TTFbars,topLine,bottomLine,T3Hot,T3Original,showTopBottomLevels,showSignals,1,y);
         sigu[i]   = EMPTY_VALUE;
         sigd[i]   = EMPTY_VALUE;
         trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TTFbars,topLine,bottomLine,T3Hot,T3Original,showTopBottomLevels,showSignals,4,y);
         trends[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TTFbars,topLine,bottomLine,T3Hot,T3Original,showTopBottomLevels,showSignals,5,y);
         
         //
         //
         //
         //
         //
         
         if (showTopBottomLevels)
         {
            trend[i] = trend[i+1];
               if (ttf[i] > 0) trend[i] =  1;
               if (ttf[i] < 0) trend[i] = -1;
               if (trend[i]== 1) lev[i] = topLine;
               if (trend[i]==-1) lev[i] = bottomLine;
         }
      
         if (showSignals)
         {
            trends[i] = 0;
               if (ttf[i] > topLine)    trends[i] =  1;
               if (ttf[i] < bottomLine) trends[i] = -1;
               if (trends[i]== 1) sigu[i] = topLine;
               if (trends[i]==-1) sigd[i] = bottomLine;
         }
   }
   return(0);
   }

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int forInstance=0)
{
   if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);

   if (workT3Coeffs[forInstance][_period] != period)
   {
     workT3Coeffs[forInstance][_period] = period;
        double a = hot;
            workT3Coeffs[forInstance][_c1] = -a*a*a;
            workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = forInstance*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[forInstance][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[r][2+buffer]);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}


